# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from enum import Enum


class Currency(str, Enum):

    usd = "USD"
    cad = "CAD"
    gbp = "GBP"
    eur = "EUR"
    cop = "COP"
    jpy = "JPY"
    cny = "CNY"
    aud = "AUD"
    inr = "INR"
    aed = "AED"
    afn = "AFN"
    all = "ALL"
    amd = "AMD"
    ang = "ANG"
    aoa = "AOA"
    ars = "ARS"
    awg = "AWG"
    azn = "AZN"
    bam = "BAM"
    bbd = "BBD"
    bdt = "BDT"
    bgn = "BGN"
    bhd = "BHD"
    bif = "BIF"
    bmd = "BMD"
    bnd = "BND"
    bob = "BOB"
    bov = "BOV"
    brl = "BRL"
    bsd = "BSD"
    btn = "BTN"
    bwp = "BWP"
    byr = "BYR"
    bzd = "BZD"
    cdf = "CDF"
    che = "CHE"
    chf = "CHF"
    chw = "CHW"
    clf = "CLF"
    clp = "CLP"
    cou = "COU"
    crc = "CRC"
    cuc = "CUC"
    cup = "CUP"
    cve = "CVE"
    czk = "CZK"
    djf = "DJF"
    dkk = "DKK"
    dop = "DOP"
    dzd = "DZD"
    egp = "EGP"
    ern = "ERN"
    etb = "ETB"
    fjd = "FJD"
    fkp = "FKP"
    gel = "GEL"
    ghs = "GHS"
    gip = "GIP"
    gmd = "GMD"
    gnf = "GNF"
    gtq = "GTQ"
    gyd = "GYD"
    hkd = "HKD"
    hnl = "HNL"
    hrk = "HRK"
    htg = "HTG"
    huf = "HUF"
    idr = "IDR"
    ils = "ILS"
    iqd = "IQD"
    irr = "IRR"
    isk = "ISK"
    jmd = "JMD"
    jod = "JOD"
    kes = "KES"
    kgs = "KGS"
    khr = "KHR"
    kmf = "KMF"
    kpw = "KPW"
    krw = "KRW"
    kwd = "KWD"
    kyd = "KYD"
    kzt = "KZT"
    lak = "LAK"
    lbp = "LBP"
    lkr = "LKR"
    lrd = "LRD"
    lsl = "LSL"
    lyd = "LYD"
    mad = "MAD"
    mdl = "MDL"
    mga = "MGA"
    mkd = "MKD"
    mmk = "MMK"
    mnt = "MNT"
    mop = "MOP"
    mro_enum = "MRO"
    mur = "MUR"
    mvr = "MVR"
    mwk = "MWK"
    mxn = "MXN"
    mxv = "MXV"
    myr = "MYR"
    mzn = "MZN"
    nad = "NAD"
    ngn = "NGN"
    nio = "NIO"
    nok = "NOK"
    npr = "NPR"
    nzd = "NZD"
    omr = "OMR"
    pab = "PAB"
    pen = "PEN"
    pgk = "PGK"
    php = "PHP"
    pkr = "PKR"
    pln = "PLN"
    pyg = "PYG"
    qar = "QAR"
    ron = "RON"
    rsd = "RSD"
    rub = "RUB"
    rwf = "RWF"
    sar = "SAR"
    sbd = "SBD"
    scr = "SCR"
    sdg = "SDG"
    sek = "SEK"
    sgd = "SGD"
    shp = "SHP"
    sll = "SLL"
    sos = "SOS"
    srd = "SRD"
    ssp = "SSP"
    std = "STD"
    syp = "SYP"
    szl = "SZL"
    thb = "THB"
    tjs = "TJS"
    tmt = "TMT"
    tnd = "TND"
    top = "TOP"
    try_enum = "TRY"
    ttd = "TTD"
    twd = "TWD"
    tzs = "TZS"
    uah = "UAH"
    ugx = "UGX"
    uyu = "UYU"
    uzs = "UZS"
    vef = "VEF"
    vnd = "VND"
    vuv = "VUV"
    wst = "WST"
    xaf = "XAF"
    xcd = "XCD"
    xof = "XOF"
    xpf = "XPF"
    yer = "YER"
    zar = "ZAR"
    zmw = "ZMW"


class ItemAvailability(str, Enum):

    discontinued = "Discontinued"
    in_stock = "InStock"
    in_store_only = "InStoreOnly"
    limited_availability = "LimitedAvailability"
    online_only = "OnlineOnly"
    out_of_stock = "OutOfStock"
    pre_order = "PreOrder"
    sold_out = "SoldOut"


class ErrorCode(str, Enum):

    none = "None"
    server_error = "ServerError"
    invalid_request = "InvalidRequest"
    rate_limit_exceeded = "RateLimitExceeded"
    invalid_authorization = "InvalidAuthorization"
    insufficient_authorization = "InsufficientAuthorization"


class ErrorSubCode(str, Enum):

    unexpected_error = "UnexpectedError"
    resource_error = "ResourceError"
    not_implemented = "NotImplemented"
    parameter_missing = "ParameterMissing"
    parameter_invalid_value = "ParameterInvalidValue"
    http_not_allowed = "HttpNotAllowed"
    blocked = "Blocked"
    authorization_missing = "AuthorizationMissing"
    authorization_redundancy = "AuthorizationRedundancy"
    authorization_disabled = "AuthorizationDisabled"
    authorization_expired = "AuthorizationExpired"


class SafeSearch(str, Enum):

    off = "Off"
    moderate = "Moderate"
    strict = "Strict"
